/****************************************/
/*  DFILE class (header)                */
/****************************************/
/* Start      : 31/5/98                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 31/5/98                 */
/* Comments   : Data file class         */
/*              Using templates         */
/****************************************/


#ifndef _VLIB_V_FILE_DFILE_H
#define _VLIB_V_FILE_DFILE_H

#include "filebase.h"

template < class T > class DFILE : public FILEBASE
{
 private:
 protected:
 public:
 private:
 protected:
  T d;          /* Store data here*/
  T *p;         /* Pointer to d */
 public:
  DFILE();
  ~DFILE();

  void Open(char *name);
  void Close();
  void Create(char *name);

  T *Get_Next();

  void Move(long n);

  void Write(T *d);
  void Write(T &d);
  T *Read();
  void Append(T *d);
  void Append(T &d);
};

#endif
