/****************************************/
/*  Double Linked List                  */
/****************************************/
/* Start      : 11/6/97                 */
/* Program ID :                         */
/* Version    : 1.02.003                */
/* End        :                         */
/* Last Update: 22/4/99                 */
/* Comments   : Using templates         */
/*                                      */
/****************************************/

#error DEPRICATED -- Use dlist3.cc

//#ifndef _DLIST_CPP
//#define _DLIST_CPP

#include "dlist.h"
//#include "mem.cc"

#define MEMCPY Memcpy

template <class ItemT> DL_List<ItemT>::DL_List(void)
{
 l=l2=NULL;
 Count=0;
}

template <class ItemT> void DL_List<ItemT>::Push(ItemT d)
{
 Push(&d);
}

template <class ItemT> void DL_List<ItemT>::PushL(ItemT d)
{
 PushL(&d);
}

template <class ItemT> void DL_List<ItemT>::Push(ItemT FAR *data1)
{
 if (!l)
 {
  l=new DListN<ItemT>;
  l->next=NULL;
  l->prev=NULL;
  MEMCPY(&(l->data),data1,sizeof(ItemT));
  l2=l;
 } else
 {
  DListN<ItemT> FAR *n;
  n=new DListN<ItemT>;
  n->next=l;
  n->prev=NULL;
  l->prev=n;
  MEMCPY(&(n->data),data1,sizeof(ItemT));
  l=n;
 }
 Count++;
}

template <class ItemT> void DL_List<ItemT>::PushL(ItemT FAR *data1)
{
 if (!l)
 {
  l=new DListN<ItemT>;
  l->next=NULL;
  l->prev=NULL;
  MEMCPY(&(l->data),data1,sizeof(ItemT));
  l2=l;
 } else
 {
  DListN<ItemT> FAR *n;
  n=new DListN<ItemT>;
  n->prev=l2;
  n->next=NULL;
  l2->next=n;
  MEMCPY(&(n->data),data1,sizeof(ItemT));
  l2=n;
 }
 Count++;
}

template <class ItemT> ItemT FAR *DL_List<ItemT>::Pop(void)
{
 DListN<ItemT> FAR *n;
 ItemT FAR *k;
 n=NULL;
 k=NULL;
 if (l)
 {
  MEMCPY(&poped,&(l->data),sizeof(ItemT));
  n=l;
  l=l->next;
  //free(n);
  delete(n);
  if (l)
   l->prev=NULL;
  else
   l2=NULL;
  k=&poped;
  Count--;
 }
 return(k);
}

template <class ItemT> ItemT FAR *DL_List<ItemT>::PopL(void)
{
 DListN<ItemT> FAR *n;
 ItemT FAR *k;
 n=NULL;
 k=NULL;
 if (l2)
 {
  MEMCPY(&poped,&(l2->data),sizeof(ItemT));
  n=l2;
  l2=l2->prev;
  //free(n);
  delete(n);
  if (l2)
   l2->next=NULL;
  else
   l=NULL;
  k=&poped;
  Count--;
 }
 return(k);
}



template <class ItemT> DL_List<ItemT>::~DL_List(void)
{
//while (Pop());  /* Empty the list */
 ClearList();
}


template <class ItemT> void DL_List<ItemT>::Rewind(void)
{
 search=l;
 searchL=l2;
}

template <class ItemT> ItemT FAR *DL_List<ItemT>::Get_Next(void)
{
 DListN<ItemT> FAR *t;
 ItemT FAR *d;
 if (search)
 {
  t=search;
  search=search->next;
  d=&(t->data);
 }
 else d=NULL;
 return(d);
}

template <class ItemT> ItemT FAR *DL_List<ItemT>::Get_Prev(void)
{
 DListN<ItemT> FAR *t;
 ItemT FAR *d;
 if (searchL)
 {
  t=searchL;
  searchL=searchL->prev;
  d=&(t->data);
 }
 else d=NULL;
 return(d);
}

template <class ItemT> void DL_List<ItemT>::InitMoving(void)
{
 moving=l;
}

template <class ItemT> void DL_List<ItemT>::InitMovingL(void)
{
 moving=l2;
}

template <class ItemT> ItemT FAR *DL_List<ItemT>::MoveLeft(void)
{
 ItemT FAR *p;
 /* return null or the element */
 if (moving->prev)
 {
  moving=moving->prev;
  p=&(moving->data);
 } else p=NULL;
 return(p);
}

template <class ItemT> ItemT FAR *DL_List<ItemT>::MoveRight(void)
{
 ItemT FAR *p;
 /* return null or the element */
 if (moving->next)
 {
  moving=moving->next;
  p=&(moving->data);
 } else p=NULL;
 return(p);
}

template <class ItemT> ItemT FAR *DL_List<ItemT>::GetCurrent(void)
{
 return(&(moving->data));
}

template <class ItemT> ItemT FAR *DL_List<ItemT>::GetN(int n)
{
 DListN<ItemT> FAR *p;
 ItemT *d;
 int k;
 p=l;
 d=NULL;
 k=0;
 while ((k<n) && (p))
 {
  p=p->next;
  k++;
 }
 if (p!=NULL) d=&(p->data);
 return(d);
}

template <class ItemT> ItemT FAR *DL_List<ItemT>::GetNL(int n)
{
 DListN<ItemT> FAR *p;
 ItemT *d;
 int k;
 p=l2;
 d=NULL;
 k=0;
 while ((k<n) && (p))
 {
  p=p->prev;
  k++;
 }
 if (p!=NULL) d=&(p->data);
 return(d);
}

template <class ItemT> void DL_List<ItemT>::ClearList(void)
{
 while (Pop());
}

//template <class ItemT> void DL_List<ItemT>::RemoveCurrent(ItemT FAR *d)
template <class ItemT> void DL_List<ItemT>::RemoveCurrent(void)
{
/* DListN<ItemT> FAR *dl;
 DListN<ItemT> FAR *dr;
 DListN<ItemT> FAR *d=moving;


 dl=d->prev;
 dr=d->next;

 if (dl!=NULL) dl->next=dr;
 if (dr!=NULL) dr->prev=dl;

 free(d);*/
 RemoveItem(moving);
}

template <class ItemT> void DL_List<ItemT>::RemoveItem(DListN<ItemT> *d)
{
 DListN<ItemT> FAR *dl;
 DListN<ItemT> FAR *dr;
 

 dl=d->prev;
 dr=d->next;
 if (dl!=NULL) dl->next=dr;
 else l=dr;  // 23/7/97
 if (dr!=NULL) dr->prev=dl;
 else l2=dl; // 23/7/97

 //free(d);
 Count--;
 delete(d);
}

template <class ItemT> void DL_List<ItemT>::RemoveItem(ItemT *d)
{
 DListN<ItemT> FAR *p;
 p=l;
 while ((&(p->data)!=d) && (p!=NULL))
 {
  p=p->next;
 }
 if (p!=NULL) // FOUND!!!
  RemoveItem(p);
}

template <class ItemT> ItemT FAR *DL_List<ItemT>::operator[](int n)
{
 return(GetN(n));
}

template <class ItemT> void DL_List<ItemT>::RemoveItem(int n)
{
 DListN<ItemT> FAR *p;
 ItemT *d;
 int k;
 p=l;
 d=NULL;
 k=0;
 while ((k<n) && (p))
 {
  p=p->next;
  k++;
 }
 if (p!=NULL)
  RemoveItem(p);
 return(d);
}

template <class ItemT> void DL_List<ItemT>::RemoveCurrent2()
{
 RemoveItem(search);
}

template <class ItemT> void DL_List<ItemT>::Append(DL_List<ItemT> &d)
{
 ItemT *p;

 d->Rewind();
 while ((p=d->Get_Next())!=NULL)
 {
  this->PushL(p);
 }
}

template <class ItemT> void DL_List<ItemT>::operator+=(DL_List<ItemT> &d)
{
 Append(d);
}

#undef MEMCPY

//#endif

