/****************************************/
/*  Double Linked List (header)         */
/****************************************/
/* Start      : 11/6/97                 */
/* Program ID :                         */
/* Version    : 1.02.003                */
/* End        :                         */
/* Last Update: 25/7/99                 */
/* Comments   : Using templates         */
/*                                      */
/****************************************/

#error DEPRICATED -- Use dlist3.h

/*
 25/7/99: Memory leak!: when using operator= , the old data were not destroyed
          Bug!: When copying the object, poped was not copyied
 22/4/99: Added: Copy constructer for DL_List (fixes bug)
          Added: operator=() for DL_List (fixes bug)
 2/4/99: Found bug! RemoveCurrent2() would erase the next.. not the 'curent'
        (Corrected only in dlist2.cpp.. not in dlist.cpp)
 28/10/98: Added public: void RemoveCurrent2();
 26/10/98: Added public: void RemoveItem(long l);
 19/9/98 : Don't use memcpy. Use = instead. Doesn't work with 
          strings.. suitable for objects..
 31/8/97: Added  public: ItemT *operator[](int n); Return(GetN(n))
 29/8/97: Added  public: long Count;  Number of items in the list
 20/8/97: Added  public: void RemoveItem(ItemT *d);
 23/7/97: Found bug! Error when removing first/last item with
          RemoveCurrent(). l and l2 should be updated!
 23/7/87: Found bug! In PushL() n->prev=l should be n->prev=l2
          Copy-Paste did this!
 6/7/97 : Use new/delete instead of malloc/free
          */

#ifndef _DLIST_HPP
#define _DLIST_HPP

//#define FAR far
#define FAR

#include "stdio.h"
/*#include "mem.h"
 #include "alloc.h"*/
#include "stdlib.h"
/*#include "conio.h"*/
/*#include "iostream.h"*/


#include "mem.h"


template <class ItemT> struct DListN
{
/* public:*/
 DListN<ItemT> FAR *next,FAR *prev;
 ItemT data;
 private:
  void vvv(DListN<ItemT> &d);
 public:
  DListN();
  ~DListN();
//  DListN(DListN<ItemT> &d);
//  DListN<ItemT> operator=(DListN<ItemT> &d);*/
};

template <class ItemT> class DL_List : public MEMORY
{
 private:
  DListN<ItemT> FAR *l; //left (list?)
  DListN<ItemT> FAR *l2; //right
  DListN<ItemT> FAR *search; //searching index
  DListN<ItemT> FAR *searchL; //searching index (for reverse searching)
  DListN<ItemT> FAR *moving; // for moving inside list (left/right)
  DListN<ItemT> FAR *last_search; // One day this will go...
  ItemT poped;
 public:
  long Count;
 private:
  void RemoveItem(DListN<ItemT> *d);
  void vvv(DL_List<ItemT> &d);
  void Construct();
 public:
  DL_List(void);
  ~DL_List(void);
  DL_List(DL_List<ItemT> &d);
  DL_List<ItemT> operator=(DL_List<ItemT> &d);
  void Push(ItemT FAR *data1); /* Add Element as first */
  void Push(ItemT d);
  void PushL(ItemT d);     /* Add Element as last */
  void PushL(ItemT FAR *d);
  ItemT FAR *Pop(void);  /* Remove first element */
  ItemT FAR *PopL(void); /* Remove last element */
  void Rewind(void); // Init search
  ItemT FAR *Get_Next(void); // Find the next one
  ItemT FAR *Get_Prev(void); // Find the prev one
  void InitMoving(void);   //Init the moving (go to first)
  void InitMovingL(void);  //Init the moving (go to last)
  ItemT FAR *GetCurrent(void); //Get the current (moving)
  ItemT FAR *MoveLeft(void);  //Go to the left(moving)
  ItemT FAR *MoveRight(void); //Go to the right(moving)
  ItemT FAR *GetN(int n); //Get the Nth element (1st = 0)
  ItemT FAR *GetNL(int n); //Get the Nth element from the end
  void ClearList(void);
  //void Remove(ItemT FAR *d); //Remove d from list
  void RemoveCurrent(void); //Remove current(moving) from list
  void RemoveItem(ItemT *d); //Find D and remove it *1*
  void RemoveCurrent2(void); //Remove current(search) from list (Get_Next())

  ItemT FAR *operator[](int n);
  void RemoveItem(int n);  //Find the Nth element and remove it

  void Append(DL_List<ItemT> &d); /* Append a list to this one */
  void operator+=(DL_List<ItemT> &d); /*      >>      >>     */
};


#endif


/*
 *1*  :  Match the pointer. Bug free???????
 */
