/****************************************/
/*  More kinds of lists (header)        */
/****************************************/
/* Start      : 30/10/98                */
/* Program ID :                         */
/* Version    : 1.01                    */
/* End        :                         */
/* Last Update: 23/7/99                 */
/* Comments   :                         */
/*                                      */
/****************************************/

#ifndef _VLIB_V_MEM_MORELISTS_H
#define _VLIB_V_MEM_MORELISTS_H

#include "v/mem/dlist3.h"
#include "v/mem/longline.h"

//#define NUMLIST	NUMLIST_OLD

class NUMLIST // Numbers List.
{
 private:
 public:
  long cmdN;    // Number of commands
  long maxcmdN;
  LONGMEM list;
  long *p;      // This is list.p
 private:
  void vvv(NUMLIST& p);
 public:
  NUMLIST();
  ~NUMLIST();
  NUMLIST(NUMLIST &p);
  NUMLIST operator=(NUMLIST& p);
  void Add(long l);  // Add Number
  void Resize(long l);
  void Del(long l);  // Remove Number
  long Exist(long l); // Find the Number and return the seq# (else return -1)
  long operator[](long l); // Same as exist, but return the contents of p[seq#]
  long Get(long l); // Return the number with seq#==l
  void Clear();
};

//#undef NUMLIST

#include "strlist.h"

/*class STRLIST // Strings list.
{
 private:
 public:
  DL_List<LONGLINE> list;
  long count;
 private:
  int GoTo(const LONGLINE &p); // Go to the element. Return 0 if not found (else 1)
  void vvv(STRLIST& p);
 public:
  STRLIST();
  ~STRLIST();
  STRLIST(STRLIST& p);
  STRLIST operator=(STRLIST& p);
  void Add(const LONGLINE& p);
  int Del(const LONGLINE& p);   // Return 1 if found, else 0
  int Exist(const LONGLINE& p);
  int operator[](const LONGLINE& p);  // Same as exist
  void Clear();
  LONGLINE *Get(long l);
  void Rewind();
  LONGLINE *Get_Next();
};
*/

#endif
