/****************************************/
/*  Virtual table                       */
/****************************************/
/* Start      : 12/9/99                 */
/* Program ID :                         */
/* Version    : 1.02                    */
/* End        :                         */
/* Last Update: 12/9/99                 */
/* Comments   : Using templates         */
/*                                      */
/****************************************/

#include "vtable.h"
#include "dlist3.cc"

template <class T> VT_OBJ<T>::VT_OBJ()
{
 index=-1;
// d=NULL;
}

template <class T> VT_OBJ<T>::~VT_OBJ()
{
// if (d!=NULL) delete(d);
}

template <class T> VT_OBJ<T>::VT_OBJ(VT_OBJ<T> &d)
{
 ddd(d);
}

template <class T> VT_OBJ<T> VT_OBJ<T>::operator=(VT_OBJ<T> &d)
{
 ddd(d);
 return (*this);
}

template <class T> void VT_OBJ<T>::ddd(VT_OBJ<T> &d)
{
/* T *p;

 index=d.index;
 if (d.d==NULL) p=NULL;
 else {p=new(T); *p=*(d.d);}
 if (this->d!=NULL) free(this->d);
 this->d=p;*/
 index=d.index;
 this->d=d.d;
}





template <class T> VTABLE<T>::VTABLE()
{
}

template <class T> VTABLE<T>::~VTABLE()
{
 Clear();
}

template <class T> void VTABLE<T>::Clear()
{
// VT_OBJ<T> *p;

/* d.Rewind();
 while ((p=d.Get_Next())!=NULL)
 {
  delete(p->d);
 }*/
 d.ClearList();
}

template <class T> VTABLE<T>::VTABLE(VTABLE<T> &d)
{
 ddd(d);
}

template <class T> VTABLE<T> VTABLE<T>::operator=(VTABLE<T> &d)
{
 ddd(d);
 return (*this);
}

template <class T> void VTABLE<T>::ddd(VTABLE<T> &d)
{
// VT_OBJ<T> *p;
// T *p2;
 // this->d=d.d;
 Clear();
/* d.d.Rewind();
 while ((p=d.d.Get_Next())!=NULL)
 {
//  p2=new(T);
//  p2=p->d;
//  Add(p->index,p2);
//  (*this)[p->index]=p->d;
//  this->d.PushL(*p);
  Add(p->index,p->d);
 }*/
 this->d=d.d;
}

template <class T> VT_OBJ<T> *VTABLE<T>::GetN(long l)
{
 VT_OBJ<T> *p;
 int OK=0;

 p=NULL;
 d.Rewind();
 while (!OK)
 {
  if ((p=d.Get_Next())==NULL) OK=1;
  else if (p->index==l) OK=1;
 }

 return(p);
}

template <class T> T *VTABLE<T>::Exist(long l)
{
 VT_OBJ<T> *p;

 p=GetN(l);
 if (p==NULL) return(NULL);
 else return(&p->d);
}

template <class T> T &VTABLE<T>::operator[](long l)
{
 T *p;

 p=Exist(l);
// if (p==NULL) { p=new(T); Add(l,p); }
 if (p==NULL) { T dd; Add(l,dd); p=Exist(l); }

 return(*p);
}

/* Add an elemnt with index index, or update the contents of element index */
template <class T> void VTABLE<T>::Add(long index, T& p)
{
 T *ret;
 VT_OBJ<T> *v;

 if ((ret=Exist(index))==NULL)
 {
  v=new(VT_OBJ<T>);
  v->index=index;
//  v->d=new(T);
//  *(v->d)=*p;
  v->d=p;
  d.PushL(v);
 }// else *ret=*p;
}

/* Delete an element (if it exist) */
template <class T> void VTABLE<T>::Del(long index)
{
 VT_OBJ<T> *p;
 int OK=0;

 p=NULL;
 d.Rewind();
 while (!OK)
 {
  if ((p=d.Get_Next())==NULL) OK=1;
//  else if (p->index==l) { delete(p->d); d.RemoveCurrent2(); OK=1; }
//  else if (p->index==l) { d.RemoveCurrent2(); OK=1; }
  else if (p->index==index) { d.RemoveCurrent(); OK=1; }
 }
}

template <class T> void VTABLE<T>::Rewind()
{
	d.Rewind();
}

template <class T> long *VTABLE<T>::Get_Next()
{
	VT_OBJ<T> *p;
	long *ret;
	
	p=d.Get_Next();
	if (p==NULL) ret=NULL;
	else
	{
		ret=&p->index;
	}
	
	return(ret);
}


template <class T> VLTABLE<T>::VLTABLE(size_t init_size)
{
 d=NULL;
 size=0;
}

template <class T> VLTABLE<T>::~VLTABLE()
{
}

template <class T> VLTABLE<T>::VLTABLE(VLTABLE<T> &d)
{
 ddd(d);
}

template <class T> VLTABLE<T> VLTABLE<T>::operator=(VLTABLE<T> &d)
{
 ddd(d);
 return (*this);
}

template <class T> void VLTABLE<T>::ddd(VLTABLE<T> &d)
{
 setsize(d.size);
 memcpy(this->d,d.d,sizeof(T)*size);
}

template <class T> void VLTABLE<T>::setsize(size_t size)
{
 d=(T *)realloc(d,sizeof(T) * size);
 this->size=size;
}

template <class T> T &VLTABLE<T>::operator[](size_t pos)
{
 if (pos>=size) setsize(pos+1);
 return(d[pos]);
}



