/****************************************/
/*  TFILE class                         */
/****************************************/
/* Start      : 20/9/98                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 20/9/98                 */
/* Comments   : Text file class         */
/*                                      */
/****************************************/

#include "tfile.h"

TFILE::TFILE()
{
 linen=0;
}

TFILE::~TFILE()
{
}

void TFILE::Open(const char *name)
{
 FILEBASE::Open(name);
 Rewind();
}

void TFILE::Close()
{
 FILEBASE::Close();
}

void TFILE::Create(const char *name)
{
 FILEBASE::Create(name);
 Rewind();
}

void TFILE::Rewind()
{
 FILEBASE::Rewind();
 linen=0;
}

LONGLINE *TFILE::Get_Next()
{
 char tmp[257];
 int n=0,m;
 tmp[256]=0;
 size_t s;

 line="";
 linen++;
 while (!n)
 {
  Fgets(tmp,256);
  line+=tmp;
  m=strlen(tmp);
  if ((m<255) || ((m==255) && (tmp[254]=='\n'))) /* We have all the line */
   n=1;
  s=strlen(line);
  if (s>=2)
   if (line[s-2]=='\n')
    line.p[s-2]=0;
 }
 return &line;
}

void TFILE::Write(const LONGLINE &p)
{
 FILEBASE::Write(p.p,strlen(p));
}

void TFILE::Append(const LONGLINE &p)
{
 Seekend();
 Write(p);
}

LONGLINE *TFILE::Read()
{
 return(Get_Next());
}

