/****************************************/
/*  MASK.VL                             */
/****************************************/
/* Start      : 24/10/96                */
/* Program ID : 0123                    */
/* Version    : 1.02                    */
/* End        :                         */
/* Last Update: 2/1/97                  */
/* Comments   : Check filename matching */
/*                                      */
/****************************************/

#include "string.h"
#include "mask.h"
#include "memory.h"
#include "stdio.h"
/*#include "D_DATA.VH"*/

int Check_Name(const char *name, const char *mask)  //return 0 if error, 1 if ok /*FOLD00*/
{
 int done=0;    //0: not done, 1:ok, 2:error
 int npos=0,mpos=0;
 int star=0;
 char c,d;
 while (!done)
 {
  d=name[npos];
  switch ((c=mask[mpos]))
  {
  case '?': npos++;mpos++;star=0;break;
  case '*': /*while (mask[mpos]=='*')*/ mpos++;
            star=1;
            break;
  case 0  : /*if (star)
            {            //Check if there are no more chars after the star
             //c=mask[mpos];
             //             while ((c) && ((c=='*') || (c=='?'))) c=mask[++mpos];  //? should be one char not 0
             while (c=='*') c=mask[++mpos];
             if (c) done=2; else done=1;
            } else
            if (!d) done=1; else done=2;  //The name should be allready matched
            break;*/
            if (star)
            {
             done=1;
            }
            else
             if (!d) done=1; else done=2;
            break;
   default :/* if (star)     // ERROR!!!!!! a*a != aaa (Found *, search for a, found the 2nd a, keep on.. No match for the 3rd(!!! :))
            {
             while ((c!=d) && (d)) d=name[++npos];
             if (!d) done=2; else {mpos++;npos++;}
             star=0;
             } else*/
             if (star)
             {
              int n=0;
              while ((!n) && (name[npos]))
              {
               n=Check_Name(&name[npos],&mask[mpos]);
               if (!n)
                npos++;
              };
              if (n)
               done=1;
              else
               done=2;
             } else
            {
             if (c!=d) done=2; else {mpos++;npos++;}
            }
            break;
  }
 }
 if (done==2) done=0;  /*done-=2;*/
 return(done);
}

int OldCheck_Name(char *name, char *mask)  //return 0 if error, 1 if ok
{
 int done=0;    //0: not done, 1:ok, 2:error
 int npos=0,mpos=0;
 int star=0;
 char c,d;
 while (!done)
 {
  d=name[npos];
  switch ((c=mask[mpos]))
  {
  case '?': npos++;mpos++;star=0;break;
  case '*': /*while (mask[mpos]=='*')*/ mpos++;
            star=1;
            break;
  case 0  : if (star)
            {            //Check if there are no more chars after the star
             //c=mask[mpos];
             //             while ((c) && ((c=='*') || (c=='?'))) c=mask[++mpos];  //? should be one char not 0
             while (c=='*') c=mask[++mpos];
             if (c) done=2; else done=1;
            } else
            if (!d) done=1; else done=2;  //The name should be allready matched
            break;
  default : if (star)
            {
             while ((c!=d) && (d)) d=name[++npos];
             if (!d) done=2; else {mpos++;npos++;}
             star=0;
            } else
            {
             if (c!=d) done=2; else {mpos++;npos++;}
            }
            break;
  }
 }
 if (done==2) done=0;  /*done-=2;*/
 return(done);
}

/*
int Check_NameNC(char *name,char *mask)
{
 char tmp1[D_MAX_FILE_NAME],tmp2[D_MAX_FILE_NAME];
 strcpy(tmp1,name);
 strcpy(tmp2,mask);
 return(Check_Name(strupr(tmp1),strupr(tmp2)));
}
*/

