/****************************************/
/*  Memory usage class                  */
/****************************************/
/* Start      : 23/6/97                 */
/* Program ID :                         */
/* Version    : 1.00                    */
/* End        :                         */
/* Last Update: 23/6/97                 */
/* Comments   : MEMORY class            */
/*              (portability??)         */
/****************************************/

#ifndef _MEM_CPP
#define _MEM_CPP

#include "mem.h"

MEMORY::MEMORY()
{
 Allocated=0;
 size=0;
}

MEMORY::~MEMORY()
{
 if (Allocated) Free();
}

pMEMORYType MEMORY::Allocate(long l)
{
 if (Allocated) Free();  /* First free the previous reserved memory */
 size=l;
 buf=(pMEMORYType)Malloc(1L*size*sizeof(MEMORYType));
 Allocated=1;
 return(buf);
}

void MEMORY::Free()
{
 if (Allocated)
 {
  free(buf);
  Allocated=0;
  size=0;
 }
}


pMEMORYType MEMORY::Malloc(long l)
{
 return((pMEMORYType)malloc(1L*l));
}

MEMORY::MEMORY(long l)
{
 Allocate(l);
}

//pMEMORYType MEMORY::Memcpy(pMEMORYType dst, pMEMORYType src, size_t n)
pMEMORYType MEMORY::Memcpy(void FAR * dst, void FAR * src, size_t n)
{
  return((pMEMORYType)memcpy(dst,src,n));
// return(memcpy(dst,src,n));
}

#endif
