/****************************************/
/*					*/
/****************************************/
/* Start      : 06/09/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 06/09/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#include "encode.h"
#include "stdio.h"

B2P::B2P()
{
}

B2P::~B2P()
{
}

B2P::B2P(B2P &d)
{
	ddd(d);
}

B2P B2P::operator=(B2P &d)
{
	ddd(d);
	return (*this);
}

void B2P::ddd(B2P &d)
{
	buf=d.buf;
	str=d.str;
}

void	B2P::setbin(const char *p, size_t len)
{
	buf.Memcpy(p,len);
	convert_b2s();
}

void	B2P::setstr(const char *p)
{
	str=p;
	convert_s2b();
}

void	B2P::convert_b2s()
{
	char	st[3];
	size_t	n;
	unsigned char c,*p;

	st[2]=0;
	str="";
	p=(unsigned char *)buf.p;
	for (n=0;n<buf.len;n++)
	{
		c=*p;
		sprintf(st,"%02X",c);
		str+=st;
		p++;
	}
}

void	B2P::convert_s2b()
{
	char		*p,st[3],*p2;
	size_t		n;
	unsigned char	c;
	char		*pbuf;

	p=str.p;
	n=0; st[2]=0;
	pbuf=(char *)malloc(1+(str.len/2));
	while ((*p!=0) && (*(p+1)!=0))
	{
		st[0]=*p; p++;
		st[1]=*p; p++;
		c=(unsigned char)strtol(st,(char **)NULL,16);
		pbuf[n]=c;
		p2++;
		n++;
	}
	buf.Memcpy(pbuf,n);
	free(pbuf);
}
