/****************************************/
/*					*/
/****************************************/
/* Start      : 06/09/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 06/09/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#ifndef _VLIB_V_MISC_ENCODE_H
#define _VLIB_V_MISC_ENCODE_H

#include "v/mem/longline.h"

/*
	Binary to printable (and vice versa) convertion
*/
class B2P
{
 private:
 public:
 	LONGMEM		buf;	// the binary
	LONGLINE	str;	// the string
 private:
	void	ddd		(B2P &d);
	void	convert_b2s	();
	void	convert_s2b	();
 public:
		B2P		();
		~B2P		();
		B2P		(B2P &d);
	B2P	operator=	(B2P &d);
	void	setbin		(const char *p, size_t len);	// set a binary buffer to be converted to string
	void	setstr		(const char *p);		// str->binary
};

#endif

