/****************************************/
/*  A random byte 'generator'		*/
/****************************************/
/* Start      : 15/07/2001		*/
/* Program ID : 			*/
/* Version    : 1.00			*/
/* End        : 			*/
/* Last Update: 15/07/2001		*/
/* Comments   : 			*/
/*                                      */
/****************************************/

#ifndef _VLIB_V_MISC_RANDOM_H
#define _VLIB_V_MISC_RANDOM_H

#include "sys/types.h"
#include "limits.h"
#include "stdlib.h"
#include "ctype.h"

class RANDOM
{
 private:
 	static long	sporos;
 public:
 private:
	void	ddd			(RANDOM &d);
	void	do_time_seed		();
	void	get_random		(char *buf, size_t buflen);	// fill buf with randm b
	void	init_sporos		();
 public:
		RANDOM			();
		~RANDOM			();
		RANDOM			(RANDOM &d);
	RANDOM	operator=		(RANDOM &d);
	operator signed long		();	// return a random long
	operator signed int		();
	operator signed short int	();
	operator signed char		();
	operator unsigned long		();	// return a random long
	operator unsigned int		();
	operator unsigned short int	();
	operator unsigned char		();

	char	*fill_buffer	(char *buf, size_t buflen);	// returns buf
	char	*fill_str	(char *buf, size_t buflen);	// same as fill_buffer, but with printable characters only
								// buf will be null terminated
};


#endif

